'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var nodePath = require('path');

exports.default = function (_ref) {
  var t = _ref.types;
  return {
    visitor: {
      Identifier: function Identifier(path, state) {
        if (path.node.name === '__filenamespace') {
          // Get user settings
          var _state$opts = state.opts;
          var separator = _state$opts.separator;
          var root = _state$opts.root;

          // Get file paths

          var _state$file$opts = state.file.opts;
          var filename = _state$file$opts.filename;
          var basename = _state$file$opts.basename;
          var sourceRoot = _state$file$opts.sourceRoot;

          var dirname = nodePath.dirname(filename);

          // Set base directory (project source + root specified)
          var userSetRoot = root;
          var projectSrc = sourceRoot;
          if (root) {
            var dotSlash = root.match(/^\.\//);
            var dotDotSlash = root.match(/^\.\.\//);
            if (dotSlash) {
              userSetRoot = userSetRoot.replace(/^\.\//, '');
            }
            if (dotDotSlash) {
              var sourcePathSegments = sourceRoot.split('/');
              var rootPathSegments = userSetRoot.split('/');
              projectSrc = rootPathSegments.filter(function (val) {
                return val.match(/^\.\.$/);
              }).reduce(function (acc) {
                return acc.slice(0, -1);
              }, sourcePathSegments).join('/');
            }
          }

          var filenamespace = dirname.replace('' + projectSrc, '');
          if (userSetRoot && filenamespace.startsWith('/' + userSetRoot)) {
            filenamespace = filenamespace.replace('' + userSetRoot, '');
          }

          // Remove filename if "index" as it is meaningless
          if (!basename.match(/index/i)) {
            filenamespace += '/' + basename;
          }

          // Strip leading path separators
          filenamespace = filenamespace.replace(/^\/+/, '');

          // Set custom separator
          if (separator) {
            filenamespace = filenamespace.replace(/\//g, separator);
          }

          // Replace __filenamespace with the transformed value
          path.replaceWith(t.stringLiteral(filenamespace));
        }
      }
    }
  };
};